Subject: Re: [RFC PATCH net-next v4 2/6] devlink: Extend devlink-rate api with queues and new parameters

From: Jakub Kicinski <[email-masked]>
Date: Thu, 22 Sep 2022 05:50:40 -0700

On Thu, 22 Sep 2022 13:44:14 +0200 Wilczynski, Michal wrote:
> Below I'll paste the output of how initially the topology looks like for our
> hardware.
> If the devlink_port objects are present (as in switchdev mode), there
> should also be vport nodes represented. It is NOT a requirement for
> a queue to have a vport as it's ancestor.

Thanks! How did you know that my preferred method of reading 
hierarchies is looking at a linear output!? 😕

Anyway. My gut feeling is that this is cutting a corner. Seems 
most natural for the VF/PF level to be controlled by the admin
and the queue level by whoever owns the queue. The hypervisor
driver/FW should reconcile the two and compile the full hierarchy.